/**************************************************************************************\
*                                                                                      *
*              The Lisa Emulator Project  V1.2.6      DEV 2007.12.04                   *
*                             http://lisaem.sunder.net                                 *
*                                                                                      *
*                  Copyright (C) 1998, 2007 Ray A. Arachelian                          *
*                                All Rights Reserved                                   *
*                                                                                      *
*           This program is free software; you can redistribute it and/or              *
*           modify it under the terms of the GNU General Public License                *
*           as published by the Free Software Foundation; either version 2             *
*           of the License, or (at your option) any later version.                     *
*                                                                                      *
*           This program is distributed in the hope that it will be useful,            *
*           but WITHOUT ANY WARRANTY; without even the implied warranty of             *
*           MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
*           GNU General Public License for more details.                               *
*                                                                                      *
*           You should have received a copy of the GNU General Public License          *
*           along with this program;  if not, write to the Free Software               *
*           Foundation, Inc., 59 Temple Place #330, Boston, MA 02111-1307, USA.        *
*                                                                                      *
*                   or visit: http://www.gnu.org/licenses/gpl.html                     *
*                                                                                      *
*                            Keyboard Scan Codes                                       *
*                                                                                      *
\**************************************************************************************/

//-----------------------------------
#define KEY_DOWN             0x80
#define KEY_UP               0x00
//-----------------------------------
#define KEYCODE_TILDE        0x68
#define KEYCODE_1            0x74
#define KEYCODE_2            0x71
#define KEYCODE_3            0x72
#define KEYCODE_4            0x73
#define KEYCODE_5            0x64
#define KEYCODE_6            0x61
#define KEYCODE_7            0x62
#define KEYCODE_8            0x63
#define KEYCODE_9            0x50
#define KEYCODE_0            0x51
#define KEYCODE_MINUS        0x40
#define KEYCODE_PLUS         0x41
#define KEYCODE_BACKSPACE    0x45
//-----------------------------------
#define KEYCODE_TAB          0x78
#define KEYCODE_Q            0x75
#define KEYCODE_W            0x77
#define KEYCODE_E            0x60
#define KEYCODE_R            0x65
#define KEYCODE_T            0x66
#define KEYCODE_Y            0x67
#define KEYCODE_U            0x52
#define KEYCODE_I            0x53
#define KEYCODE_O            0x5f
#define KEYCODE_P            0x44
#define KEYCODE_OBRAK        0x56
#define KEYCODE_CBRAK        0x57
#define KEYCODE_BSLASH       0x42
//-----------------------------------
#define KEYCODE_CAPSLOCK     0x7d
#define KEYCODE_A            0x70
#define KEYCODE_S            0x76
#define KEYCODE_D            0x7b
#define KEYCODE_F            0x69
#define KEYCODE_G            0x6a
#define KEYCODE_H            0x6b
#define KEYCODE_J            0x54
#define KEYCODE_K            0x55
#define KEYCODE_L            0x59
#define KEYCODE_COLON        0x5a
#define KEYCODE_QUOTE        0x5b
#define KEYCODE_UNUSED1      0x42
#define KEYCODE_RETURN       0x48
//-----------------------------------
#define KEYCODE_SHIFT        0x7e
#define KEYCODE_UNUSED2      0x43
#define KEYCODE_Z            0x79
#define KEYCODE_X            0x7a
#define KEYCODE_C            0x6d
#define KEYCODE_V            0x6c
#define KEYCODE_B            0x6e
#define KEYCODE_N            0x6f
#define KEYCODE_M            0x58
#define KEYCODE_COMMA        0x5d
#define KEYCODE_DOT          0x5e
#define KEYCODE_FSLASHQ      0x4c
#define KEYCODE_SHIFT        0x7e
//-----------------------------------
#define KEYCODE_LOPTION      0x7c
#define KEYCODE_OPTION       0x7c
#define KEYCODE_COMMAND      0x7f
#define KEYCODE_LEFTCMD      0x7f
#define KEYCODE_SPACE        0x5c
#define KEYCODE_LENTER       0x46
#define KEYCODE_ROPTION      0x4e
//-----------------------------------
#define KEYCODE_CLEAR        0x20
#define KEYCODE_MINUS_NUM    0x21
#define KEYCODE_PLUS_NUM     0x22
#define KEYCODE_STAR_NUM     0x23
#define KEYCODE_7NUM         0x24
#define KEYCODE_8NUM         0x25
#define KEYCODE_9NUM         0x26
#define KEYCODE_FSLASH       0x27
#define KEYCODE_4NUM         0x28
#define KEYCODE_5NUM         0x29
#define KEYCODE_6NUM         0x2a
#define KEYCODE_COMMA_NUM    0x2b
#define KEYCODE_1NUM         0x4d
#define KEYCODE_2NUM         0x2d
#define KEYCODE_3NUM         0x2e
#define KEYCODE_ENTERNUM     0x2f
#define KEYCODE_0NUM         0x49
#define KEYCODE_DOTNUM       0x2c
//-----------------------------------
#define KEYCODE_CURSORL      0x22
#define KEYCODE_CURSORR      0x23
#define KEYCODE_CURSORU      0x27
#define KEYCODE_CURSORD      0x2B
//-----------------------------------

